type 'a u = {
    conj :    'a;
    disj :    'a;
    xor :     'a;
    equ :     'a;
    imp :     'a;
    closed :  'a;
    it_conj : 'a;
    it_disj : 'a;
    loop :    'a;
    lemmas :  'a;
    initial_shift : 'a;
    min_shift : 'a;
  }

  type t = int ref u

  val new_counter : upper_bound:Indexes.t option -> t
  val update_min_shift : Indexes.t -> t -> unit
  val incr : (t -> unit) u
  val set : (t -> int -> unit) u
  val to_string : t -> string
  val (^^) : ('a -> unit) -> ('a -> unit) -> ('a -> unit)
